### Virtual Method

# FwupdPlugin Backend create_device_for_donor

since: 2.0.0

#### Declaration [src]

    FuDevice*
    create_device_for_donor (
      FuBackend* self,
      FuDevice* donor,
      GError** error
    )

#### Description [src]

Asks the backend to create a device (of the correct type) for a given donor device.

Available since: 2.0.0

#### Parameters

`donor`

  Type: `FuDevice`

  A donor `FuDevice`.

  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `FuDevice`

A `FuDevice` or `NULL` if not found or unimplemented.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.